using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace AsyncMethods
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnEnd;
		private System.Windows.Forms.Button btnIsComplete;
		private System.Windows.Forms.Button btnCallback;
		private System.Windows.Forms.Label lblEnd;
		private System.Windows.Forms.Label lblIsComplete;
		private System.Windows.Forms.Label lblCallback;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{			
			InitializeComponent();			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnEnd = new System.Windows.Forms.Button();
			this.btnIsComplete = new System.Windows.Forms.Button();
			this.btnCallback = new System.Windows.Forms.Button();
			this.lblEnd = new System.Windows.Forms.Label();
			this.lblIsComplete = new System.Windows.Forms.Label();
			this.lblCallback = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btnEnd
			// 
			this.btnEnd.Location = new System.Drawing.Point(8, 16);
			this.btnEnd.Name = "btnEnd";
			this.btnEnd.TabIndex = 0;
			this.btnEnd.Text = "End";
			this.btnEnd.Click += new System.EventHandler(this.btnEnd_Click);
			// 
			// btnIsComplete
			// 
			this.btnIsComplete.Location = new System.Drawing.Point(8, 56);
			this.btnIsComplete.Name = "btnIsComplete";
			this.btnIsComplete.TabIndex = 1;
			this.btnIsComplete.Text = "IsComplete";
			this.btnIsComplete.Click += new System.EventHandler(this.btnIsComplete_Click);
			// 
			// btnCallback
			// 
			this.btnCallback.Location = new System.Drawing.Point(8, 96);
			this.btnCallback.Name = "btnCallback";
			this.btnCallback.TabIndex = 2;
			this.btnCallback.Text = "Callback";
			this.btnCallback.Click += new System.EventHandler(this.btnCallback_Click);
			// 
			// lblEnd
			// 
			this.lblEnd.Location = new System.Drawing.Point(104, 16);
			this.lblEnd.Name = "lblEnd";
			this.lblEnd.Size = new System.Drawing.Size(168, 23);
			this.lblEnd.TabIndex = 3;
			// 
			// lblIsComplete
			// 
			this.lblIsComplete.Location = new System.Drawing.Point(104, 56);
			this.lblIsComplete.Name = "lblIsComplete";
			this.lblIsComplete.Size = new System.Drawing.Size(168, 23);
			this.lblIsComplete.TabIndex = 4;
			// 
			// lblCallback
			// 
			this.lblCallback.Location = new System.Drawing.Point(104, 96);
			this.lblCallback.Name = "lblCallback";
			this.lblCallback.Size = new System.Drawing.Size(168, 23);
			this.lblCallback.TabIndex = 5;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.lblCallback);
			this.Controls.Add(this.lblIsComplete);
			this.Controls.Add(this.lblEnd);
			this.Controls.Add(this.btnCallback);
			this.Controls.Add(this.btnIsComplete);
			this.Controls.Add(this.btnEnd);
			this.Name = "Form1";
			this.Text = "  ";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnEnd_Click(object sender, System.EventArgs e)
		{
			AsynchronousMethodDelegate asyncDeleg = new 
				AsynchronousMethodDelegate(AsynchronousMethod);
			//    AsynchronousMethod.
			IAsyncResult ar = asyncDeleg.BeginInvoke(ActivateType.End, null, null);
			//     .
			lblEnd.Text = asyncDeleg.EndInvoke(ar);
		}

		private void btnIsComplete_Click(object sender, System.EventArgs e)
		{
			AsynchronousMethodDelegate asyncDeleg = new 
				AsynchronousMethodDelegate(AsynchronousMethod);
		//    AsynchronousMethod.
			IAsyncResult ar = asyncDeleg.BeginInvoke(ActivateType.IsColplete, null, null);
			while(!ar.IsCompleted)
			{
				lblIsComplete.Text = "";
			}
			//     .
			lblIsComplete.Text = asyncDeleg.EndInvoke(ar);
		}

		private void btnCallback_Click(object sender, System.EventArgs e)
		{
			AsynchronousMethodDelegate asyncDeleg = new 
				AsynchronousMethodDelegate(AsynchronousMethod);
			//   callback   Callback.
			AsyncCallback callback = new AsyncCallback(CallbackMethod);
				//    AsynchronousMethod.
			asyncDeleg.BeginInvoke(ActivateType.Callback, callback, asyncDeleg);
		}
		/// <summary>
		///         callback
		/// </summary>
		/// <param name="ar"></param>
		private void CallbackMethod(IAsyncResult ar)
		{
			//     AsynchronousMethodDelegate
			AsynchronousMethodDelegate asyncDeleg = (AsynchronousMethodDelegate)ar.AsyncState;
				//     .
			lblCallback.Text = asyncDeleg.EndInvoke(ar);
		}
		
		private delegate string AsynchronousMethodDelegate(ActivateType source);

		/// <summary>
		///  ,    .
		/// </summary>
		/// <param name="source">  .</param>
		/// <returns></returns>
		private string AsynchronousMethod(ActivateType source)
		{
			string result = String.Empty;
			switch(source)
			{
				case ActivateType.Callback:
					result = "Callback";
					break;
				case ActivateType.End:
					result = "End";
					break;
				case ActivateType.IsColplete:
					result = "Is Complete";
					break;
			}
			return result;
		}
		/// <summary>
		///    .
		/// </summary>
		private enum ActivateType
		{
			End,
			IsColplete,
			Callback
		}
	}
}
